import _CodeMirror from "codemirror";
import type { App } from "vue";
import type { EditorConfiguration } from "codemirror";
import codemirror from "./src/components/index.vue";
declare interface InstallConfig {
    events: any[];
    options: EditorConfiguration;
}
export * from ".";
declare const CodeMirror: typeof _CodeMirror;
declare const install: (app: App, config?: InstallConfig | undefined) => App<any>;
export * from "./src/components/presetMode/log/utils";
export { CodeMirror, codemirror, install };
declare const _default: {
    CodeMirror: typeof _CodeMirror;
    codemirror: import("vue").DefineComponent<{
        value: {
            type: import("vue").PropType<string>;
            default: string;
        };
        options: {
            type: import("vue").PropType<_CodeMirror.EditorConfiguration>;
            default: () => {
                mode: string;
                theme: string;
                lineNumbers: boolean;
                smartIndent: boolean;
                indentUnit: number;
            };
        };
        globalOptions: {
            type: import("vue").PropType<_CodeMirror.EditorConfiguration>;
            default: () => {
                mode: string;
                theme: string;
                lineNumbers: boolean;
                smartIndent: boolean;
                indentUnit: number;
            };
        };
        placeholder: {
            type: import("vue").PropType<string>;
            default: string;
        };
        border: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        width: {
            type: import("vue").PropType<string | number>;
            default: null;
        };
        height: {
            type: import("vue").PropType<string | number>;
            default: null;
        };
        keepCursorInEnd: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        merge: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        name: {
            type: import("vue").PropType<string>;
            default: string;
        };
        marker: {
            type: import("vue").PropType<() => HTMLElement>;
            default: () => null;
        };
        unseenLines: {
            type: import("vue").PropType<any[]>;
            default: () => never[];
        };
    }, {
        presetModeName: import("vue").Ref<"Default" | "Merge" | "FcLog">;
        cmOptions: any;
        cminstance: import("vue").Ref<{
            hasFocus: () => boolean;
            findPosH: (start: _CodeMirror.Position, amount: number, unit: string, visually: boolean) => {
                line: number;
                ch: number;
                hitSide?: boolean | undefined;
            };
            findPosV: (start: _CodeMirror.Position, amount: number, unit: string) => {
                line: number;
                ch: number;
                hitSide?: boolean | undefined;
            };
            findWordAt: (pos: _CodeMirror.Position) => _CodeMirror.Range;
            setOption: <K extends keyof _CodeMirror.EditorConfiguration>(option: K, value: _CodeMirror.EditorConfiguration[K]) => void;
            getOption: <K_1 extends keyof _CodeMirror.EditorConfiguration>(option: K_1) => _CodeMirror.EditorConfiguration[K_1];
            addKeyMap: (map: string | _CodeMirror.KeyMap, bottom?: boolean | undefined) => void;
            removeKeyMap: (map: string | _CodeMirror.KeyMap) => void;
            addOverlay: (mode: any, options?: {
                opaque?: boolean | undefined;
                priority?: number | undefined;
            } | undefined) => void;
            removeOverlay: (mode: any) => void;
            getDoc: () => _CodeMirror.Doc;
            swapDoc: (doc: _CodeMirror.Doc) => _CodeMirror.Doc;
            getValue: (seperator?: string | undefined) => string;
            setValue: (content: string) => void;
            getCursor: (start?: string | undefined) => _CodeMirror.Position;
            setCursor: (pos: number | _CodeMirror.Position, ch?: number | undefined, options?: {
                bias?: number | undefined;
                origin?: string | undefined;
                scroll?: boolean | undefined;
            } | undefined) => void;
            setGutterMarker: (line: any, gutterID: string, value: HTMLElement | null) => _CodeMirror.LineHandle;
            clearGutter: (gutterID: string) => void;
            addLineClass: (line: any, where: string, _class_: string) => _CodeMirror.LineHandle;
            removeLineClass: (line: any, where: string, class_?: string | undefined) => _CodeMirror.LineHandle;
            lineAtHeight: (height: number, mode?: _CodeMirror.CoordsMode | undefined) => number;
            heightAtLine: (line: any, mode?: _CodeMirror.CoordsMode | undefined, includeWidgets?: boolean | undefined) => number;
            lineInfo: (line: any) => {
                line: any;
                handle: any;
                text: string;
                gutterMarkers: any;
                textClass: string;
                bgClass: string;
                wrapClass: string;
                widgets: any;
            };
            addWidget: (pos: _CodeMirror.Position, node: HTMLElement, scrollIntoView: boolean) => void;
            addLineWidget: (line: any, node: HTMLElement, options?: _CodeMirror.LineWidgetOptions | undefined) => _CodeMirror.LineWidget;
            setSize: (width: any, height: any) => void;
            scrollTo: (x?: number | null | undefined, y?: number | null | undefined) => void;
            getScrollInfo: () => _CodeMirror.ScrollInfo;
            scrollIntoView: (pos: _CodeMirror.Position | {
                line: number;
                ch: number;
            } | {
                left: number;
                top: number;
                right: number;
                bottom: number;
            } | {
                from: _CodeMirror.Position;
                to: _CodeMirror.Position;
            } | null, margin?: number | undefined) => void;
            cursorCoords: (where?: boolean | _CodeMirror.Position | null | undefined, mode?: _CodeMirror.CoordsMode | undefined) => {
                left: number;
                top: number;
                bottom: number;
            };
            charCoords: (pos: _CodeMirror.Position, mode?: _CodeMirror.CoordsMode | undefined) => {
                left: number;
                right: number;
                top: number;
                bottom: number;
            };
            coordsChar: (object: {
                left: number;
                top: number;
            }, mode?: _CodeMirror.CoordsMode | undefined) => _CodeMirror.Position;
            defaultTextHeight: () => number;
            defaultCharWidth: () => number;
            getViewport: () => {
                from: number;
                to: number;
            };
            refresh: () => void;
            getModeAt: (pos: _CodeMirror.Position) => _CodeMirror.Mode<unknown>;
            getTokenAt: (pos: _CodeMirror.Position, precise?: boolean | undefined) => _CodeMirror.Token;
            getTokenTypeAt: (pos: _CodeMirror.Position) => string;
            getLineTokens: (line: number, precise?: boolean | undefined) => _CodeMirror.Token[];
            getStateAfter: (line?: number | undefined) => any;
            operation: <T>(fn: () => T) => T;
            startOperation: () => void;
            endOperation: () => void;
            indentLine: (line: number, dir?: string | undefined) => void;
            indentSelection: (how: string) => void;
            isReadOnly: () => boolean;
            toggleOverwrite: (value?: boolean | undefined) => void;
            execCommand: (name: string) => void;
            focus: () => void;
            phrase: (text: string) => unknown;
            getInputField: () => HTMLTextAreaElement;
            getWrapperElement: () => HTMLElement;
            getScrollerElement: () => HTMLElement;
            getGutterElement: () => HTMLElement;
            on: {
                <T_1 extends keyof _CodeMirror.EditorEventMap>(eventName: T_1, handler: _CodeMirror.EditorEventMap[T_1]): void;
                <K_2 extends "mousedown" | "dblclick" | "touchstart" | "contextmenu" | "keydown" | "keypress" | "keyup" | "dragstart" | "dragenter" | "dragover" | "dragleave" | "drop">(eventName: K_2, handler: (instance: _CodeMirror.Editor, event: GlobalEventHandlersEventMap[K_2]) => void): void;
                <K_3 extends "cut" | "copy" | "paste">(eventName: K_3, handler: (instance: _CodeMirror.Editor, event: DocumentAndElementEventHandlersEventMap[K_3]) => void): void;
            };
            off: {
                <T_2 extends keyof _CodeMirror.EditorEventMap>(eventName: T_2, handler: _CodeMirror.EditorEventMap[T_2]): void;
                <K_4 extends "mousedown" | "dblclick" | "touchstart" | "contextmenu" | "keydown" | "keypress" | "keyup" | "dragstart" | "dragenter" | "dragover" | "dragleave" | "drop">(eventName: K_4, handler: (instance: _CodeMirror.Editor, event: GlobalEventHandlersEventMap[K_4]) => void): void;
                <K_5 extends "cut" | "copy" | "paste">(eventName: K_5, handler: (instance: _CodeMirror.Editor, event: DocumentAndElementEventHandlersEventMap[K_5]) => void): void;
            };
            state: any;
            modeOption: string | {
                highlightNonStandardPropertyKeywords?: boolean | undefined;
                version?: 2 | 3 | undefined;
                singleLineStringErrors?: boolean | undefined;
                hangingIndent?: number | undefined;
                singleOperators?: unknown;
                singleDelimiters?: unknown;
                doubleOperators?: unknown;
                doubleDelimiters?: unknown;
                tripleDelimiters?: unknown;
                identifiers?: unknown;
                extra_keywords?: string[] | undefined;
                extra_builtins?: string[] | undefined;
                useCPP?: boolean | undefined;
                base?: string | undefined;
                tags?: {
                    [x: string]: unknown;
                } | undefined;
                json?: boolean | undefined;
                jsonld?: boolean | undefined;
                typescript?: boolean | undefined;
                trackScope?: boolean | undefined;
                statementIndent?: boolean | undefined;
                wordCharacters?: unknown;
                highlightFormatting?: boolean | undefined;
                maxBlockquoteDepth?: boolean | undefined;
                xml?: boolean | undefined;
                fencedCodeBlockHighlighting?: boolean | undefined;
                fencedCodeBlockDefaultMode?: string | undefined;
                tokenTypeOverrides?: unknown;
                allowAtxHeaderWithoutSpace?: boolean | undefined;
                gitHubSpice?: boolean | undefined;
                taskLists?: boolean | undefined;
                strikethrough?: boolean | undefined;
                emoji?: boolean | undefined;
                leftDelimiter?: string | undefined;
                rightDelimiter?: string | undefined;
                baseMode?: string | undefined;
                inMathMode?: boolean | undefined;
                noIndentKeywords?: unknown;
                atoms?: unknown;
                hooks?: unknown;
                multiLineStrings?: boolean | undefined;
                htmlMode?: boolean | undefined;
                matchClosing?: boolean | undefined;
                alignCDATA?: boolean | undefined;
                name: string;
            };
            getRange: (from: _CodeMirror.Position, to: _CodeMirror.Position, seperator?: string | undefined) => string;
            replaceRange: (replacement: string | string[], from: _CodeMirror.Position, to?: _CodeMirror.Position | undefined, origin?: string | undefined) => void;
            getLine: (n: number) => string;
            setLine: (n: number, text: string) => void;
            removeLine: (n: number) => void;
            lineCount: () => number;
            firstLine: () => number;
            lastLine: () => number;
            getLineHandle: (num: number) => _CodeMirror.LineHandle;
            getLineNumber: (handle: _CodeMirror.LineHandle) => number | null;
            eachLine: {
                (f: (line: _CodeMirror.LineHandle) => void): void;
                (start: number, end: number, f: (line: _CodeMirror.LineHandle) => void): void;
            };
            markClean: () => void;
            changeGeneration: (closeEvent?: boolean | undefined) => number;
            isClean: (generation?: number | undefined) => boolean;
            getSelection: () => string;
            getSelections: (lineSep?: string | undefined) => string[];
            replaceSelection: (replacement: string, collapse?: string | undefined) => void;
            replaceSelections: (replacements: string[], collapse?: string | undefined) => void;
            listSelections: () => _CodeMirror.Range[];
            somethingSelected: () => boolean;
            setSelection: (anchor: _CodeMirror.Position, head?: _CodeMirror.Position | undefined, options?: {
                bias?: number | undefined;
                origin?: string | undefined;
                scroll?: boolean | undefined;
            } | undefined) => void;
            setSelections: (ranges: {
                anchor: _CodeMirror.Position;
                head: _CodeMirror.Position;
            }[], primary?: number | undefined, options?: _CodeMirror.SelectionOptions | undefined) => void;
            addSelection: (anchor: _CodeMirror.Position, head?: _CodeMirror.Position | undefined) => void;
            extendSelection: (from: _CodeMirror.Position, to?: _CodeMirror.Position | undefined, options?: _CodeMirror.SelectionOptions | undefined) => void;
            extendSelections: (heads: _CodeMirror.Position[], options?: _CodeMirror.SelectionOptions | undefined) => void;
            extendSelectionsBy: (f: (range: _CodeMirror.Range) => _CodeMirror.Position) => void;
            setExtending: (value: boolean) => void;
            getExtending: () => boolean;
            linkedDoc: (options: {
                sharedHist?: boolean | undefined;
                from?: number | undefined;
                to?: number | undefined;
                mode?: string | _CodeMirror.ModeSpec<_CodeMirror.ModeSpecOptions> | undefined;
            }) => _CodeMirror.Doc;
            unlinkDoc: (doc: _CodeMirror.Doc) => void;
            iterLinkedDocs: (fn: (doc: _CodeMirror.Doc, sharedHist: boolean) => void) => void;
            undo: () => void;
            redo: () => void;
            undoSelection: () => void;
            redoSelection: () => void;
            historySize: () => {
                undo: number;
                redo: number;
            };
            clearHistory: () => void;
            getHistory: () => any;
            setHistory: (history: any) => void;
            markText: (from: _CodeMirror.Position, to: _CodeMirror.Position, options?: _CodeMirror.TextMarkerOptions | undefined) => _CodeMirror.TextMarker<_CodeMirror.MarkerRange>;
            setBookmark: (pos: _CodeMirror.Position, options?: {
                widget?: HTMLElement | undefined;
                insertLeft?: boolean | undefined;
                shared?: boolean | undefined;
                handleMouseEvents?: boolean | undefined;
            } | undefined) => _CodeMirror.TextMarker<_CodeMirror.Position>;
            findMarks: (from: _CodeMirror.Position, to: _CodeMirror.Position) => _CodeMirror.TextMarker<_CodeMirror.Position | _CodeMirror.MarkerRange>[];
            findMarksAt: (pos: _CodeMirror.Position) => _CodeMirror.TextMarker<_CodeMirror.Position | _CodeMirror.MarkerRange>[];
            getAllMarks: () => _CodeMirror.TextMarker<_CodeMirror.Position | _CodeMirror.MarkerRange>[];
            removeLineWidget: (widget: _CodeMirror.LineWidget) => void;
            getMode: () => _CodeMirror.Mode<unknown>;
            lineSeparator: () => string;
            posFromIndex: (index: number) => _CodeMirror.Position;
            indexFromPos: (object: _CodeMirror.Position) => number;
        } | null>;
        content: import("vue").Ref<string>;
        ready: () => void;
        resize: (width?: string | number, height?: string | number) => void;
        refresh: () => void;
        containerHeight: import("vue").Ref<string | null>;
        instanceName: string | undefined;
        presetRef: import("vue").Ref<null>;
    }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
        [x: string]: any;
        "update:value": (value: string) => string;
        change: (value: string, cm: _CodeMirror.Editor) => {
            value: string;
            cm: _CodeMirror.Editor;
        };
        input: (value: string) => string;
        ready: (cm: _CodeMirror.Editor) => _CodeMirror.Editor;
    }, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<{
        value?: unknown;
        options?: unknown;
        globalOptions?: unknown;
        placeholder?: unknown;
        border?: unknown;
        width?: unknown;
        height?: unknown;
        keepCursorInEnd?: unknown;
        merge?: unknown;
        name?: unknown;
        marker?: unknown;
        unseenLines?: unknown;
    } & {
        name: string;
        value: string;
        options: _CodeMirror.EditorConfiguration;
        placeholder: string;
        globalOptions: _CodeMirror.EditorConfiguration;
        border: boolean;
        width: string | number;
        height: string | number;
        keepCursorInEnd: boolean;
        merge: boolean;
        marker: () => HTMLElement;
        unseenLines: any[];
    } & {}> & {
        [x: string & `on${string}`]: ((...args: any[]) => any) | ((...args: unknown[]) => any) | undefined;
    }, {
        name: string;
        value: string;
        options: _CodeMirror.EditorConfiguration;
        placeholder: string;
        globalOptions: _CodeMirror.EditorConfiguration;
        border: boolean;
        width: string | number;
        height: string | number;
        keepCursorInEnd: boolean;
        merge: boolean;
        marker: () => HTMLElement;
        unseenLines: any[];
    }>;
    install: (app: App<any>, config?: InstallConfig | undefined) => App<any>;
};
export default _default;
