import { Editor, EditorConfiguration } from "codemirror";

declare global {
  interface Window {
    diff_match_patch: any;
    DIFF_DELETE: number;
    DIFF_INSERT: number;
    DIFF_EQUAL: number;
  }
  type Nullable<T> = T | null;
}

export declare interface CmProps {
  value: string;
  options?: EditorConfiguration;
  globalOptions?: EditorConfiguration;
  placeholder?: string;
  border?: boolean;
  width: string | number;
  height: string | number;
  keepCursorInEnd: boolean;
  merge?: boolean;
  name?: string;
  marker?: () => HTMLElement;
  unseenLines?: Array<any>;
}

declare module "codemirror";
